<div id="content">xd</div>
<div id="debug"></div>


<script>
// Settings

debug = false
isFront = true

let textAll = "{{Text}}"
let textHidden = "{{cloze:Text}}"
let el = document.getElementById("content")
let deb = document.getElementById("debug")

let reAll = /\{\{c\d+::\[\[(.*?)\|(.*?)\]\]\}\}/gm
let reHidden = /(?:\[\[(.*?)\|(.*?)\]\]|(?<=\<span class=cloze\>)\[.*\](?=\<\/span\>))/gm
let answersAll = getAllRegex(textAll, reAll)
let answersHidden = getAllRegex(textHidden, reHidden)
let hiddenId = getAnswerId(textHidden, answersHidden, isFront)

t = getText(textHidden, answersHidden, answersAll, hiddenId, isFront)
el.innerHTML = t
if(debug) {
	deb.innerHTML = getAnswerId(textHidden, answersHidden)
}

function getAnswerId(textHidden, answersHidden, isFront) {
	if(isFront) {
		return getHiddenId(answersHidden)
	}
	else {
		return getAnswerIdForBack(textHidden, answersHidden)
	}
}

function getAnswerIdForBack(textHidden, answersHidden) {
	let id
	let reAns = /(?<=\<span class=cloze\>)\[.*\](?=\<\/span\>)/gm
	let ans = getAllRegex(textHidden, reAns)
	for(let i=0; i < answersHidden.length; i++) {
		if(answersHidden[i].index === ans[0].index) {
			id = i
		}
	}
	return id
}

function getText(textHidden, answersHidden, answersAll, hiddenId, isFront) {
	if(isFront === true) {
		answer = answersAll[hiddenId].match[1]
		answersHidden[hiddenId].match[1] = answer
		return getOnlyOnePrev(textHidden, answersHidden, hiddenId)
	}
	else {
		return showAll(textHidden, answersHidden, hiddenId)
	}
}

function showAll(textAll, answersAll, hiddenId) {
	let t = ""
	for(let i=0; i<answersAll.length; i++) {
		t += getTextId(textAll, answersAll, i)
		if(i === hiddenId - 1) {
			t += answersAll[i].match[1]
		}
		else if(i === hiddenId) {
			t += answersAll[i].match[1]
		}
		else {
			t += makeHiddenAnswer(answersAll[i].match[1], "black", "black-hidden", i)
		}
	}
	t += getTextId(textAll, answersAll, answersAll.length)
	return t
}

function getOnlyOnePrev(textAll, answersAll, hiddenId) {
	let t = ""
	for(let i=0; i<=answersAll.length; i++) {
		t += getTextId(textAll, answersAll, i)
		if(i === hiddenId - 1) {
			t += answersAll[i].match[1]
		} 
		else if(i === hiddenId) {
			t += makeHiddenAnswer(answersAll[i].match[1], "cloze", "cloze-hidden", i)
		} 
		else if(i < answersAll.length) {
			t += "[...]"
		}
	}
	return t
}

function makeHiddenAnswer(a, c, ch, id) {
	t = ""
	t += "<span onselectstart='return false' id='answer"+ id +"' class='" + c + " " + ch + "' onclick='document.getElementById(\"answer" + id + "\").classList.toggle(\"" + ch + "\")'>" + a + "</span>"
	return t
}

function getHiddenId(answersHidden) {
	for(let i=0; i<answersHidden.length; i++) {
		if(answersHidden[i].match[0] === "[...]") {
			return i
		}
	}
	return -1
}

function getTextId(textAll, answersAll, id) {
	if(id >= answersAll.length) {
		return textAll.substring(answersAll[answersAll.length - 1].index)
	}
	return getTextBeforeAnswer(textAll, id === 0?0:answersAll[id-1].index, answersAll[id])
}

function getTextBeforeAnswer(text, start, place) {
	return text.substring(start, place.index - place.match[0].length)
}

function getAllRegex(text, re) {
	let res = []
	let match
	do {
		match = re.exec(text)
		if(match) {
			res.push({"match": match, "index": re.lastIndex})
			//res.push(re.lastIndex)
		}
	} while(match)
	return res
}

function htmlEncode ( html )
{
    html = $.trim(html);
    return html.replace(/[&"'\<\>]/g, function(c) 
    {
          switch (c) 
          {
              case "&":
                return "&amp;";
              case "'":
                return "&#39;";
              case '"':
                return "&quot;";
              case "<":
                return "&lt;";
              default:
                return "&gt;";
          }
    });
};
</script>